/****************************************************************************************
*	Corso di Fondamenti di Informatica - Ingegneria per l'ambiente e il territorio	*
*	Programma 2: Il problema dell'assegno bancario					*
*	Finalita': Uso dei costrutti di controllo e manipolazione stringhe		*
*****************************************************************************************/

/* program assegno */
/* programma realizzato per il libro:
 * ``Pascal e C: guida pratica all programmazione''
 * M. Gori, P. Nesi, E. Pasca 
 * Software di pubblico dominio reperibile su ftp.dsi.unifi.it
 * directory:  pub\librofi
 */

/**************** Formalizzazione del problema *********************************
  Dato un numero intero con non piu' di tre cifre (x: 0<=x<=999), si determini 
  la corrispondente rappresentazione in lettere. Per esempio, x=326 deve essere
  convertito in "trecentoventisei".
********************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef char string20 [20]; /* definizione di un tipo stringa di 20 char */

const char *Unita[9] =
            {"uno","due","tre","quattro","cinque","sei","sette","otto","nove"};
const char *Decine[9] =
            {"dieci","venti","trenta","quaranta","cinquanta","sessanta",
             "settanta","ottanta","novanta"};
const char *Da11a19[9] = 
            {"undici","dodici","tredici","quattordici","quindici","sedici",
             "diciasette","diciotto","diciannove"};
const char Cento[] = "cento";

int CDU,DU,C,D,U;
string20 StringaC, StringaCA, StringaD, StringaU;
char NumeroInLettere[80];   /* Risultato della conversione */

void main()
{  /* azzera il contenuto delle stringhe */
StringaC[0] = StringaCA[0] = StringaD[0] = StringaU[0] = '\0';
NumeroInLettere[0] = '\0';

printf("Conversione di un numero in lettere\n");

/* acquisizione del numero, costituito al massimo da tre cifre */
printf("Inserisci il numero "); 
scanf("%d",&CDU);
if ((CDU < 1) || (CDU > 999))
  { 
	printf("Numero non ammesso!\n");  
	exit(0); 
  }

/* estrai le singole cifre decimali C, D e U dal numero CDU */
C = CDU / 100;   /* centinaia */
DU = CDU % 100;  /* decine e unita' */
D = DU / 10;    /* decine */
U = DU % 10;    /* unita'*/

/* gestione della maggioranza dei casi */
   /* centinaia */
   if (C > 0) {
      strcpy(StringaC, Unita[C-1]);
      strcpy(StringaCA, Cento);
      }
   /* decine */
   if (D > 0)  strcpy(StringaD, Decine[D-1]);
   /* unita' e numeri compresi fra 11 e 19 */
   if (U > 0)  
     if (D != 1)  strcpy(StringaU, Unita[U-1]); 
     else {
        StringaD[0] = '\0';
        strcpy(StringaU, Da11a19[U-1]);
        }

/* gestione delle eccezioni secondarie */
   /* si dice "cento..." e non "unocento..." */ 
   if (C == 1) StringaC[0] = '\0';
   /* presenza di doppie vocali nella concatenazione fra decine
      ed unita': si dice "ventotto" e non "ventiotto" 
      si riduce di uno la lunghezza di StringD */
   if ((D > 1) && ((U == 1) || (U == 8))) StringaD[strlen(StringaD)-1] = '\0';
 
/* concatena le stringhe ricavate separatamente */
strcpy(NumeroInLettere,StringaC);
strcat(NumeroInLettere,StringaCA);
strcat(NumeroInLettere,StringaD);
strcat(NumeroInLettere,StringaU);

/* visualizza il risultato */
printf("%d = %s\n",CDU,NumeroInLettere);
};



