/************************************************************************
*		Fondamenti di Informatica: Definizione della Classe Point		*
************************************************************************/

#include "stdlib.h"
#include "stdio.h"
#include "math.h"
#include "conio.h"
#define CLRSCR puts("\33[2J") // Pulizia schermo

/*Definizione della Classe con i suoi attributi e metodi*/

class Point
{
private:
	double x,y; // Coordinate
public:
	Point(); // Costruttore  di default
	Point( Point &altro); // Costruttore di copia
	Point( double xx, double  yy); // Costruttore con argomenti
	// METODI  FUNZIONALI
	double Get_x(); // restituisce x
	double Get_y(); // restituisce y
	void set ( double xx, double  yy); // impostazione coordinate
	// OPERATORI DI POINT
	Point operator-();
	Point operator=( Point &a);
	Point operator+=( Point &a);
	int operator==(Point &a);
	int operator!=(Point &a);
	Point operator+(Point &a);
	Point operator-(Point &a);
	// per il prodotto di una costante per un vettore
	Point operator*(double a);
};

//IMPLEMENTAZIONE DEI METODI
// Costruttori
	Point::Point() : x(0.0), y(0.0) {}

	Point::Point( double xx, double  yy ) : x(xx), y(yy) {} // x=xx; y=yy;

	Point::Point( Point &altro) : x(altro.Get_x()), y(altro.Get_y()) {}

// Metodi selettori
	double Point::Get_x() {return x;}

	double Point::Get_y() {return y;}

	void Point::set (double xx, double yy) {x=xx; y=yy;}

// Metodi Operatori
	Point Point::operator-() {return Point(-x,-y);}

	Point Point::operator+(Point &a) { return Point(a.x+x, a.y+y);}

	Point Point::operator-(Point &a) { return Point(x-a.x, y-a.y);}
	// l'ordine in cui si considerano i termini e' importante in quanto non vi  simmetria a-b!=b-a.
	// Il termine da considerare per primo  l'oggetto sul quale e' applicato l'operatore


	Point Point::operator=(Point &a) { x=a.x; y=a.y; return (*this);}

	Point Point::operator+=(Point &a) { x+=a.x; y+=a.y; return (*this);}

	int Point::operator==(Point &a) { return (a.x==x && a.y==y);}

	int Point::operator!=(Point &a) { return (a.x!=x && a.y!=y);}

	Point Point::operator*(double a) { return Point(x*a,y*a);}

/***************************************************************************************************/
	// funzione per la stampa su video delle coordinate del punto a
	void printpoint(char *msg, Point &a)
	{
		printf("%s (%f, %f)\n", msg, a.Get_x(), a.Get_y());
	}
	// funzione per il calcolo della distanza euclidea tra due punti a e b

	// modulo = radice quadrata (x^2+y^2)
	double modulo(Point &a)
	{
		return sqrt(a.Get_x()*a.Get_x() + a.Get_y()*a.Get_y());
	}

	double dist(Point &a, Point &b)
	{
		return modulo(a-b);
	}
/**************************************************************************************************/

	void main(void)
	{
		Point p1; // Viene utilizzato il costruttore di default
		Point p2(3.0,2.5); // Viene utilizzato il costruttore con gli argomenti
		Point p3(p2); // Viene utilizzato il costruttore di copia

		Point *p4, *p5; // Dichiarazioni di variabili puntatore alla classe Point.
						// L'oggetto Point non e' ancora fisicamente presente in memoria


		p4 = new Point; // Viene utilizzato il costruttore di default
		p5 = new Point(2.5, -6.0); // Viene utilizzato il costruttore con gli argomenti

		double xx, yy;
		CLRSCR;
		//Immissione dei punti p1 e p4
		printf("Immettere le coordinate del punto P1\n");
		printf("x=");
		scanf("%lf",&xx);
		printf("\n");
		printf("y=");
		scanf("%lf",&yy);
		printf("\n");

		// l'assegnazione dei valori
		p1=Point(xx,yy);

		printf("\nImmettere le coordinate del punto P4\n");
		printf("x=");
		scanf("%lf",&xx);
		printf("\n");
		printf("y=");
		scanf("%lf",&yy);

		// l'assegnazione dei valori
		p4->set(xx,yy);


		if (p2==p3)
		{
			printf("\n I punti p2 e p3 sono uguali\n"); // p2.operator==(p3); e rende un int
			printpoint("p3=",p3);
		}
		// operazioni sui punti p1, p2, p4 il risultato memorizzato in p3

		p3=p1+(p2-*p4); //p3.operator=(p1.operator+(p2.operator-(*p4)));
		printpoint("p1=", p1);
		printpoint("p2=", p2);
		printpoint("p4=", *p4);

		printpoint("p3=p1+(p2-p4)=", p3);

		// p1=p1+p5
		p1+=*p5;
		printpoint("p5=",*p5);
		printpoint("p1=p1+p5", p1);

		// calcolo della distanza tra p2 e p4

		printf("dist(p2,p4)= %f\n",dist(p2,*p4));

		//operatore unario -
		printpoint("-p1=", -p1);

		//calcolo del baricentro
		printpoint("baricentro dei punti p1, p2, p3, p4 e p5 =", (p1+p2+p3+*p4+*p5)*(1./5));
		printf("\n\n\n");
		printf("Premere un tasto per uscire");
		getch();
	}