#include "stdlib.h"
#include "stdio.h"

class Point
{
private:
	double x,y; // Coordinate
public:
	Point(); // Costruttore  di default
	Point( Point &altro); // Costruttore di copia
	Point( double xx, double  yy); // Costruttore con argomenti
	// METODI  FUNZIONALI
	double Get_x(); // restituisce x
	double Get_y(); // restituisce y
	void set ( double xx, double  yy); // impostazione coordinate
	// OPERATORI DI POINT
	Point operator-();
	Point operator=( Point &a);
	Point operator+=( Point &a);
	int operator==(Point &a);
	int operator!=(Point &a);
	Point operator+(Point &a);
	Point operator-(Point &a);
	// per il prodotto di una costante per un vettore
	Point operator*(double a);
};

//IMPLEMENTAZIONE DEI METODI
// Costruttori
	Point::Point() : x(0.0), y(0.0) {}

	Point::Point( double xx, double  yy ) : x(xx), y(yy) {} // x=xx; y=yy;

	Point::Point( Point &altro) : x(altro.Get_x()), y(altro.Get_y()) {}

// Metodi selettori
	double Point::Get_x() {return x;}

	double Point::Get_y() {return y;}

	void Point::set (double xx, double yy) {x=xx; y=yy;}

// Metodi Operatori
	Point Point::operator-() {return Point(-x,-y);}

	Point Point::operator+(Point &a) { return Point(a.x+x, a.y+y);}

	Point Point::operator-(Point &a) { return Point(x-a.x, y-a.y);}
	// l'ordine in cui si considerano i termini e' importante in quanto non vi  simmetria a-b!=b-a.
	// Il termine da considerare per primo  l'oggetto sul quale e' applicato l'operatore


	Point Point::operator=(Point &a) { x=a.x; y=a.y; return (*this);}

	Point Point::operator+=(Point &a) { x+=a.x; y+=a.y; return (*this);}

	int Point::operator==(Point &a) { return (a.x==x && a.y==y);}

	int Point::operator!=(Point &a) { return (a.x!=x && a.y!=y);}

	Point Point::operator*(double a) { return Point(x*a,y*a);}

