/****************************************************************
* Fondamenti di Informatica - Implementazione di una Rubrica	*
* Versione con i puntatori - Gestione di una lista				*
* Definizione della classi Studente - Indirizzo - Rubrica		*
****************************************************************/

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "conio.h"

#define DIMSTR 50

// new
// #define DIMRUB 100

class Indirizzo
{
	char via[DIMSTR], citta[DIMSTR], loc[DIMSTR];
        int num;
public:
	Indirizzo();
	void getdati(void);
	void getdati(Indirizzo &);
	void stampa(void);
	void set_via(char * via, int numero);
	void set_loc(char * localita, char * citta);	
        void modifica(void); // modifica 
    Indirizzo operator=(Indirizzo &); // assegnazione
};

/*****************************************************************/

// new
class Studente
{
	char nome[DIMSTR], cognome[DIMSTR];
	Indirizzo indir;  // indirizzo
	int eta;  
	char tel[DIMSTR]; // telefono
	Studente * next;
public:
	Studente(void);
	Studente(char *, char *);
	char * get_nome(void);
	char * get_cognome(void);
	char * get_telefono(void );
	int get_eta(void); 
	void set_nome_cognome(char * nome, char * cognome);
	void set_eta_telefono(int, char * telefono);
	void set_indirizzo(Indirizzo & ); 
	void stampa(void);  // stampa dati
 	void getdati(void); // richiesta dati da tastiera
        void modifica(void); // modifica 
        Studente operator=(Studente &); // assegnazione
	Studente * get_next(void);
	void set_next(Studente *);
};

/*****************************************************************/
// new
Studente * Studente::get_next(void) { return (next); }

// new
void Studente::set_next(Studente * a) { next=a; }

/*****************************************************************/

//new
Studente::Studente(void) { nome[0]=cognome[0]=tel[0]=eta=0; next=NULL; }

// new
Studente::Studente(char *a,char *b)
   { strcpy(nome,a); strcpy(cognome,b); tel[0]=eta=0; next=NULL; }

char * Studente::get_nome(void) { return nome; }

char * Studente::get_cognome(void) { return cognome ; }

char * Studente::get_telefono(void ) { return tel; }
int Studente::get_eta(void) { return eta ; } 

void Studente::set_nome_cognome(char * a, char * b) 
     { strcpy(nome,a);  strcpy(cognome,b); }

void Studente::set_eta_telefono(int a, char * b) 
     { eta=a; strcpy(cognome,b); }

void Studente::set_indirizzo(Indirizzo & a) { indir.getdati(a); }

void Studente::stampa(void)
{ 
	printf ("%s %s \n", nome, cognome);
	indir.stampa();
	printf ("%d anni, tel: %s \n", eta, tel);  
}

//new
void Studente::getdati(void)
{ 
	printf ("Nome = "); scanf("%s", nome);
	printf ("cognome = "); scanf("%s", cognome);
	printf ("tel = "); scanf("%s", tel);
	printf ("eta' = "); scanf("%d", &eta);
	indir.getdati();
}

Studente Studente::operator=(Studente &a) 
  { 
	  strcpy(nome, a.nome);   
	  strcpy(cognome, a.cognome);
	  indir=a.indir;            
	  strcpy(tel, a.tel);
	  eta= a.eta;               
	  return (*this); 
  }

void Studente::modifica(void)
{ 
	printf ("Nome = %s : ", nome); scanf("%s", nome);
	printf ("Cognome = %s : ", cognome); scanf("%s", cognome);
	printf ("Tel = %s : ", tel); scanf("%s", tel);
	printf ("Eta' = %d : ", eta); scanf("%d", &eta);
	indir.modifica();
}

/*********************************************************************/
Indirizzo::Indirizzo() { via[0]=citta[0]=loc[0]=num=0; }

void Indirizzo::getdati(void)
{	
	printf ("Via = "); scanf("%s", via);
	printf ("Numero = "); scanf("%d", &num);
	printf ("Citta' = "); scanf("%s", citta);
	printf ("Localita' = "); scanf("%s", loc);
}

void Indirizzo::getdati(Indirizzo & a) 
{ 
	strcpy(via,a.via); 
	strcpy(citta, a.citta); 
	strcpy(loc, a.loc); 
	num=a.num; 
}

void Indirizzo::stampa(void)
{ printf ("%s, %d\n%s, %s\n", via, num, loc, citta); }

void Indirizzo::set_via(char * a, int b) { strcpy(via,a); num=b; }

void Indirizzo::set_loc(char *a,char *b) {strcpy(loc,a); strcpy(citta,b);}

Indirizzo Indirizzo::operator=(Indirizzo &a) 
{ 
	strcpy(via, a.via);   
	strcpy(loc, a.loc);
	num=a.num;              
	strcpy(citta, a.citta);
	return (*this); 
}

void Indirizzo::modifica(void)
{ 
	printf ("Via = %s : ", via);       scanf("%s", via);
	printf ("Numero = %d : ", num);    scanf("%d", &num);
	printf ("Citta' = %s : ", citta);   scanf("%s", citta);
	printf ("Localita' = %s : ", loc); scanf("%s", loc);
}

/********************************************************************/

// new
class Rubrica
{
    int num;  // numero degli elementi 
    Studente *start;  
public:
	Rubrica(); // costruttore
	void stampa(void); // stampa a video
	Studente * ricerca(char * chiave); // ricerca esaustiva
	int inserimento(Studente *); // inserimento da studente
	int inserimentoTesta(Studente *); // inserimento da studente
        int cancella(char *); // cancellazione 
        int modifica(char *); // modifica 
};


/*******************************************************************/
// new
Rubrica::Rubrica() { num=0; start=NULL; }

// new
int Rubrica::inserimentoTesta(Studente * pastud)
{
	if (pastud==NULL) return(1); // operazione non possibile
	if (start==NULL) // inizio di una lista
	{ 
		start = pastud; 
		return(0); 
	} 

	pastud->set_next(start); 
	start=pastud; // aggiornamento del puntatore di partenza
	return(0);
}

// new
int Rubrica::inserimento(Studente * pastud)
{ 
	int ret;
	Studente *ptmp=NULL;

	if (start==NULL)  // lista vuota
	  return(inserimentoTesta(pastud) ); 

	ptmp=start;
	ret = strcmp(ptmp->get_cognome(), pastud->get_cognome() );
	if (ret==0) 
	  { 
		printf("Studente gia' presente \n"); 
	    ptmp->stampa();
	    return(1);
	  }
	else if (ret>0) // studente da inserire prima del primo
	  return( inserimentoTesta(pastud) ); 

	// ricerca se lo studente e' gia' inserito e della posizione
	while (ptmp->get_next()!=NULL)
	  { 
		ret = strcmp((ptmp->get_next())->get_cognome(), pastud->get_cognome() );
		if (ret==0) 
		{ 
			printf("Studente gia' presente \n"); 
			(ptmp->get_next())->stampa();
			return(1);
		}
		else if (ret>0) break; // posizione di inserimento trovata
		ptmp=ptmp->get_next(); // passaggio al successivo
	  }
	// ptmp indica l'oggetto prima della posizione di inserimento
 
	// inserimento
	pastud->set_next(ptmp->get_next());
	ptmp->set_next(pastud);

	// aggiornamento del valore di num
	num++;
	return(0);
}

/*****************************************************************/

// new
void Rubrica::stampa(void) // stampa a video
{ 
	Studente *ptmp=start;
	int i=0;
	while (ptmp!=NULL) 
	  { 
		printf("--------Studente %d -----------\n", i); 
		ptmp->stampa(); 
		ptmp=ptmp->get_next();
		printf("Premi un tasto per continuare \n");
		getch();
	  }
}

// new
Studente * Rubrica::ricerca(char * chiave)   // ricerca esaustiva
{ 
	Studente *ptmp=start;
	while (ptmp!=NULL) 
	  { if (strcmp(ptmp->get_cognome(), chiave)==0) 
		  return ( ptmp );
		ptmp=ptmp->get_next();
	  }
	return(NULL);
}

// new
int Rubrica::cancella(char * chiave) // cancellazione 
{ 
	int ret;
	Studente *ptmp=NULL, *prevptmp;

	ptmp=start;
	ret = strcmp(ptmp->get_cognome(), chiave); 
	if (ret==0) // cancellazione in testa
	  { 
		start=start->get_next(); // aggiornamento dello start
		delete(ptmp);  // deallocazione
		num--; // aggiornamento del numero 
		return(0);
	  }
	prevptmp=ptmp; // aggiornamento del puntatore precedente
	ptmp=ptmp->get_next(); // passaggio al successivo

	while (ptmp!=NULL) 
	  { 
		if ( strcmp( ptmp->get_cognome(), chiave)==0 ) // trovato
		{ 
			prevptmp->set_next(ptmp->get_next()); // ristabilisce i legami
			delete(ptmp);  // deallocazione
			num--; // aggiornamento del numero 
			return(0);
		} 
		prevptmp=ptmp;  // aggiornamento del puntatore precedente
		ptmp=ptmp->get_next(); // passaggio al successivo
	  }

	return(1);
}

// new
int Rubrica::modifica(char * chiave) // cancellazione 
{ 
	Studente *ptmp=start, *std;
	char nometmp[DIMSTR];
	int ret;

	while (ptmp!=NULL) 
	  { 
		if (strcmp(ptmp->get_cognome(), chiave)==0)  // trovato
		{ 
			strcpy(nometmp, ptmp->get_cognome() ); // salvo la chiave
			ptmp->modifica(); // modifica dello studente
			if ( strcmp(nometmp, ptmp->get_cognome())!=0 ) // cambio chiave !
			{ 
				std = new Studente(); // alloco un nuovo studente
				*std = *ptmp; // ci copio il vecchio valore
				std->set_next(NULL); // impongo nullo il suo next
				cancella(ptmp->get_cognome()); // cancello lo studente fuori posto 
				ret=inserimento(std); // inserisco il nuovo studente
				if (ret!=0) return(1);
			}
			return(0);
		}
		ptmp=ptmp->get_next(); // passaggio al successivo
	  }
	return(1); // non trovato
}

/********************************************************************/

// new
void main(void)
{ 
	char c, buf[DIMSTR];
	Rubrica lamia; 
	Studente stmp, *pstmp; // puntatore a uno studente temporaneo
	int ret, flg=0;
	pstmp = new Studente();
	do {
	   printf("\nRubrica, operazioni: \n\n");
	   printf("a) inserisci \n");
	   printf("b) stampa \n");
	   printf("c) ricerca \n");
	   printf("d) cancella \n");
	   printf("e) modifica \n");
	   printf("q) esci \n\n"); 
	   printf("Premi un tasto: ");
	   c=getch();
	   printf("\n");
	   switch(c)
		  { 
			case'a': case 'A':
				 pstmp= new Studente();
				 if (pstmp==NULL) 
					printf("Operazione impossibile\n");
				 else
				   { pstmp->getdati();
				   ret=lamia.inserimento(pstmp);   
				   if (ret!=0) printf("Operazione impossibile\n");
				   }
				 break;
			case 'b':  case 'B': 
				 lamia.stampa(); break;
			case 'c':  case 'C': 
				 printf("Studente da cercare, cognome ?: "); 
				 scanf("%s", buf);
				 pstmp=lamia.ricerca(buf);
				 if (pstmp==NULL) { printf("Studente non trovato\n"); break; }
				 pstmp->stampa();    
				 break;
			case 'd':  case 'D':
				 printf("Studente da cancellare, cognome ?: "); 
				 scanf("%s", buf);
				 ret=lamia.cancella(buf);    
				 if (pstmp==NULL) { printf("Studente non trovato\n"); break; }
				 break;
		    case 'e':  case 'E':
				 printf("Studente da modificare, cognome ?: "); 
				 scanf("%s", buf);
				 ret=lamia.modifica(buf);    
				 if (pstmp==NULL) { printf("Studente non trovato\n"); break; }
				 break;
 		    case 'q':  case 'Q': 
				 flg=1;
				 break; // uscita
		    default: printf("Operazione non consentita \n"); break;
		  }  
	   if (flg==0)
		  { 
			printf("Premi un tasto per un'altra operazione\n"); 
			getch(); 
		  }
	   } while (flg!=1);
}


/***************************************************************/





