/****************************************************************
* Fondamenti di Informatica - Implementazione di una Rubrica	*
*																*
* Definizione della classi Studente - Indirizzo - Rubrica		*
****************************************************************/

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "conio.h"

#define DIMSTR 50	//Dimensione massima di una Stringa

#define DIMRUB 100	//Dimensione della Rubrica


// new
class Indirizzo
{
	char via[DIMSTR], citta[DIMSTR], loc[DIMSTR];
        int num;
public:
	Indirizzo();
	void getdati(void);
	void getdati(Indirizzo &);
	void stampa(void);
	void set_via(char * via, int numero);
	void set_loc(char * localita, char * citta);	
        void modifica(void); // modifica 
    Indirizzo operator=(Indirizzo &); // assegnazione
};

/*****************************************************************/

// new
class Studente
{
	char nome[DIMSTR], cognome[DIMSTR];
	Indirizzo indir;  // indirizzo - Is_Part_of
	int eta;  
	char tel[DIMSTR]; // telefono
public:
	Studente(void);
	Studente(char *, char *);
	char * get_nome(void);
	char * get_cognome(void);
	char * get_telefono(void );
	int get_eta(void); 
	void set_nome_cognome(char * nome, char * cognome);
	void set_eta_telefono(int, char * telefono);
	void set_indirizzo(Indirizzo & ); 
	void stampa(void);  // stampa dati
 	void getdati(void); // richiesta dati da tastiera
        void modifica(void); // modifica 
        Studente operator=(Studente &); // assegnazione
};

/*****************************************************************/
Studente::Studente(void) { nome[0]=cognome[0]=tel[0]=eta=0; }

Studente::Studente(char *a,char *b)
   { strcpy(nome,a); strcpy(cognome,b); tel[0]=eta=0; }

char * Studente::get_nome(void) { return nome; }

char * Studente::get_cognome(void) { return cognome ; }

char * Studente::get_telefono(void ) { return tel; }
int Studente::get_eta(void) { return eta ; } 

void Studente::set_nome_cognome(char * a, char * b) 
     { strcpy(nome,a);  strcpy(cognome,b); }

void Studente::set_eta_telefono(int a, char * b) 
     { eta=a; strcpy(cognome,b); }

void Studente::set_indirizzo(Indirizzo & a) { indir.getdati(a); }

void Studente::stampa(void)
{	
	printf ("%s %s \n", nome, cognome);
	indir.stampa();
	printf ("%d anni, tel: %s \n", eta, tel);  
}

void Studente::getdati(void)
{ 
	printf ("Nome = "); scanf("%s", nome);
	printf ("cognome = "); scanf("%s", cognome);
	printf ("tel = "); scanf("%s", tel);
	printf ("eta' = "); scanf("%d", &eta);
	indir.getdati();
}

Studente Studente::operator=(Studente &a) 
  { 
	strcpy(nome, a.nome);   
	strcpy(cognome, a.cognome);
	indir=a.indir;            
	strcpy(tel, a.tel);
	eta= a.eta;               
	return (*this); 
  }

// new
void Studente::modifica(void)
{ 
	printf ("Nome = %s : ", nome); scanf("%s", nome);
	printf ("cognome = %s : ", cognome); scanf("%s", cognome);
	printf ("tel = %s : ", tel); scanf("%s", tel);
	printf ("eta' = %d : ", eta); scanf("%d", &eta);
	indir.modifica();
}

/*********************************************************************/
Indirizzo::Indirizzo() { via[0]=citta[0]=loc[0]=num=0; }

void Indirizzo::getdati(void)
{	
	printf ("Via = "); scanf("%s", via);
	printf ("Numero = "); scanf("%d", &num);
	printf ("Citta = "); scanf("%s", citta);
	printf ("Localita' = "); scanf("%s", loc);
}

void Indirizzo::getdati(Indirizzo & a) 
{	
	strcpy(via,a.via); strcpy(citta, a.citta); 
	strcpy(loc, a.loc); num=a.num; 
}

void Indirizzo::stampa(void)
{ printf ("%s, %d\n%s, %s\n", via, num, loc, citta); }

void Indirizzo::set_via(char * a, int b) { strcpy(via,a); num=b; }

void Indirizzo::set_loc(char *a,char *b) {strcpy(loc,a); strcpy(citta,b);}

Indirizzo Indirizzo::operator=(Indirizzo &a) 
  { 
	strcpy(via, a.via);   
	strcpy(loc, a.loc);
	num=a.num;              
	strcpy(citta, a.citta);
	return (*this); 
  }

// new
void Indirizzo::modifica(void)
{ 
	printf ("Via = %s : ", via);       scanf("%s", via);
	printf ("Numero = %d : ", num);    scanf("%d", &num);
	printf ("Citta = %s : ", citta);   scanf("%s", citta);
	printf ("Localita' = %s : ", loc); scanf("%s", loc);
}

/********************************************************************/

// new
class Rubrica
{
    int num;  // numero degli elementi 
    Studente vs[DIMRUB];  //Is_Part_Of 1:N (N=DIMRUB)
public:
	Rubrica(); // costruttore
	void stampa(void); // stampa a video
	Studente * ricercaDT(char * chiave); // ricerca DICOTOMICA
	Studente * ricercaDTR(char * chiave); // ricerca dicotomica ricorsiva
	Studente * ricerca(char * chiave); // ricerca esaustiva
	int salva(char * namefile);
	int carica(char * namefile);
	int ricercaDTR(int ii, int it, char * chiave);	 // passo elementare della DTR
	int inserimento(Studente &); // inserimento da studente
	void cancella(int pos); // cancellazione
	void svuota(void);
        int cancella(Studente *); // cancellazione 
        int modifica(Studente *); // modifica 
};


/*******************************************************************/
Rubrica::Rubrica() 
{ 
	num=0; 

	vs[0].set_nome_cognome("A","Armen");
	vs[1].set_nome_cognome("B","Bianch");
	vs[2].set_nome_cognome("C","Cocci");
	vs[3].set_nome_cognome("D","Doder");
	vs[4].set_nome_cognome("E","Gaggi");
	vs[5].set_nome_cognome("F","Herri");
	vs[6].set_nome_cognome("G","Iazzi");
	vs[7].set_nome_cognome("H","Luzzas");
	vs[8].set_nome_cognome("I","Massi");
	vs[9].set_nome_cognome("L","Mussi");
	vs[10].set_nome_cognome("M","Zezzi");

	num=11;

}

void Rubrica::svuota(void)
{
	num=0;
}

int Rubrica::salva(char * namefile)
{
	FILE *gt;
	int i;

	gt=fopen(namefile,"wb+");
	if (gt==NULL) return(1);
	for (i=0;i<num;i++) fwrite( &(vs[i]), sizeof(Studente), 1, gt);
	fclose(gt);
	return(0);
}

int esiste_file(char nome[])
{
	FILE *hand;					 
	
	hand=fopen(nome,"r");
	if (hand==NULL) 
		return(0); 
	fclose(hand); 
	return(1);
}

int Rubrica::carica(char * namefile)
{
	FILE *gt;
	if (num!=0) return(2); // dati presenti
	if (esiste_file(namefile)) 
	  { 
		gt=fopen(namefile,"rb+");
		while (!feof(gt)) 
		{ 
			fread(&(vs[num]),sizeof(Studente),1,gt); 
			num++; 
		}
		num--;
		fclose(gt);
	  }
	else return (1);  // il file non esiste
	return(0);
}


int Rubrica::inserimento(Studente & astud)
{ 
int ret, i;
int pos=0; // per garantire l'inserimento del primo
if (num>=DIMRUB) return(1); // Rubrica piena

// ricerca se lo studente e gia inserito e della posizione
for (i=0;i<num;i++)
  { ret = strcmp(vs[i].get_cognome(), astud.get_cognome() );
  if (ret==0) 
    { printf("Studente gia presente \n"); 
    vs[i].stampa();
    return(0);
    }
  else if (ret>0) { pos=i; break; } // posizione trovata
  }
if (i==num) pos=i; // inserimento nell'ultima posizione
 
// spostamento per fare il posto al nuovo studente
for (i=num-1;i>=pos;i--) 
  { // printf ("copio %d in %d \n", i, i+1); 
  vs[i+1]=vs[i];
  }

// inserimento
vs[pos]=astud;

// aggiornamento del valore di num
num++;

return(0);
}

/*****************************************************************/

void Rubrica::stampa(void) // stampa a video
{ int i;
for (i=0;i<num;i++) 
  { printf("--------Studente numero %d-----------\n", i); 
  vs[i].stampa(); 
  printf("Premi un tasto");
  if (i+1==num) printf(" per finire\n"); 
  else printf(" per vedere il prossimo\n");
  getch();
  }
}

Studente * Rubrica::ricerca(char * chiave)   // ricerca esaustiva
{ int i;
for (i=0;i<num;i++)
  if (strcmp(vs[i].get_cognome(), chiave)==0) 
    return ( &(vs[i]) );

return(NULL);
}

Studente * Rubrica::ricercaDT(char * chiave)  //Ricerca dicotomica
{ 
int ii=0, it=num, im, ret;
if (num==0) return NULL; // vettore vuoto
do { im=(it+ii)/2;
  printf("ii %d, it %d, im %d\n", ii, it, im);
  ret=strcmp(vs[im].get_cognome(), chiave);
  if ( ret>0 )  // di sopra
     { it=im-1; }
  else if ( ret<0 ) // di sotto
     { ii=im+1; }
  else return ( &(vs[im]) ); 
  } while (it>=ii);

printf("esco con ii %d, it %d, im %d\n", ii, it, im);
return(NULL);
}


int lev=0;

Studente * Rubrica::ricercaDTR(char * chiave)  
{ 
int ii=0, it=num, ret;
if (num==0) return NULL; // vettore vuoto

lev=0;

ret=ricercaDTR(ii,it, chiave);
if (ret<0) return (NULL);
return ( &(vs[ret]) );
}

int Rubrica::ricercaDTR(int ii, int it, char *chiave)
{
int ret1=0, ret=0, im, i;
lev++;
if (it<ii) return (-1);

im=(it+ii)/2;
for (i=0;i<lev;i++) printf("  ");
printf("R: ii %d, it %d, im %d, ret %d, ret1 %d \n", ii, it, im, ret, ret1);

ret1=strcmp(vs[im].get_cognome(), chiave);
if ( ret1>0 )      ret=ricercaDTR(ii, im-1, chiave);
else if ( ret1<0 ) ret=ricercaDTR(im+1, it, chiave);
else ret=im;     
for (i=0;i<lev;i++) printf("  ");
printf("R: ret1 %d, ret %d \n", ret1, ret); 

lev--;
return(ret);
}


void Rubrica::cancella(int pos) // cancellazione 
{ int i;
Studente s; // uno studente vuoto

if (pos!=DIMRUB-1) for (i=pos;i<num;i++) vs[i]=vs[i+1];
else vs[pos]=s; // considerazione dell'ultimo elemento 

// aggiorno il numero degli elementi
num--;
}

int Rubrica::cancella(Studente * pastud) // cancellazione 
{ int i, pos=DIMRUB+1;
//for (i=0;i<num;i++) if ( pastud==&(vs[i]) ) pos=i;
//if (pos==DIMRUB+1) return (1);

pos=(pastud-&vs[0]); 

cancella(pos);

return(0);
}

// new
int Rubrica::modifica(Studente * pastud) // cancellazione 
{ 
	int i, pos=DIMRUB+1, ret=0;
	char nometmp[DIMSTR];
	Studente std;

	for (i=0;i<num;i++) if ( pastud==&(vs[i]) ) pos=i;
	if (pos==DIMRUB+1) return (1);
	strcpy(nometmp, vs[pos].get_cognome() );
	vs[pos].modifica();
	if ( strcmp(nometmp, vs[pos].get_cognome())!=0 ) // cambio chiave
	{ 
		std=vs[pos];
		cancella(pos); 
		ret=inserimento(std);
		if (ret!=0) return(1);
	}
return(0);
}


/********************************************************************/

// new
void main(void)
{ char c, buf[DIMSTR];
Rubrica lamia; 
Studente stmp, *pstmp; // puntatore a uno studente temporaneo
int ret, flg=0;
pstmp = new Studente();
do {
   printf("\nRubrica, operazioni: \n\n");
   printf("a) inserisci \n");
   printf("b) stampa \n");
   printf("c) ricerca \n");
   printf("f) ricerca Dicotomica \n");
   printf("g) ricerca Dicotomica ricorsiva \n");
   printf("d) cancella \n");
   printf("e) modifica \n");
   printf("l) carica \n");
   printf("m) salva \n");
   printf("n) svuota \n");
   printf("q) esci \n\n"); 
   printf("Premi un tasto: ");
   c=getch();
   printf("\n");
   switch(c)
      { case'a': case 'A':
         stmp.getdati();
         ret=lamia.inserimento(stmp);   
         if (ret!=0) 
            printf("Rubrica completa ! Operazione impossibile\n");
         break;
      case 'b':  case 'B': 
         lamia.stampa(); break;
      case 'c':  case 'C': 
         printf("Studente da cercare, cognome ?: "); 
         scanf("%s", buf);
         pstmp=lamia.ricerca(buf);
         if (pstmp==NULL) { printf("Studente non trovato\n"); break; }
         pstmp->stampa();    
         break;
      case 'f':  case 'F': 
         printf("Studente da cercare DT, cognome ?: "); 
         scanf("%s", buf);
         pstmp=lamia.ricercaDT(buf);
         if (pstmp==NULL) { printf("Studente non trovato\n"); break; }
         pstmp->stampa();    
         break;
      case 'g':  case 'G': 
         printf("Studente da cercare DT ricorsiva, cognome ?: "); 
         scanf("%s", buf);
         pstmp=lamia.ricercaDTR(buf);
         if (pstmp==NULL) { printf("Studente non trovato\n"); break; }
         pstmp->stampa();    
         break;
      case 'd':  case 'D':
         printf("Studente da cancellare, cognome ?: "); 
         scanf("%s", buf);
         pstmp=lamia.ricerca(buf);
         if (pstmp==NULL) { printf("Studente non trovato\n"); break; }
         ret=lamia.cancella(pstmp);    
         if (ret!=0) printf("problemi di Cancellazione\n"); 
         break;
      case 'e':  case 'E':
         printf("Studente da modificare, cognome ?: "); 
         scanf("%s", buf);
         pstmp=lamia.ricerca(buf);
         if (pstmp==NULL) { printf("Studente non trovato\n"); break; }
         ret=lamia.modifica(pstmp);    
         if (ret!=0) printf("problemi di Modifica\n"); 
         break;
      case 'l':  case 'L':
         printf("File Rubrica da Caricare?: ");
         scanf("%s", buf);
         ret=lamia.carica(buf);
		 if (ret==1) printf("Il File non esiste \n");
		 else if (ret==2) printf ("Svuotare la Rubrica prima \n");
         break;
      case 'm':  case 'M':
         printf("File Rubrica da Salvare?: ");
         scanf("%s", buf);
         ret=lamia.salva(buf);
		 if (ret!=0) printf("Problemi di salvataggio \n");
         break;
      case 'n':  case 'N':
         printf("Svuotare (s/n)?: ");
         c=getch();
         if (c=='s') 
			{ lamia.svuota();
		    printf("Svuotata!\n");
			}
         break;
      case 'q':  case 'Q': 
         flg=1;
         break; // uscita
      default: printf("Operazione non consentita \n"); break;
      }  
   if (flg==0)
      { printf("Premi un tasto per un'altra operazione\n"); 
      getch(); 
      }
   } while (flg!=1);
}


/***************************************************************/





